// ColorDepthDlg.cpp : implementation file
//

#include "stdafx.h"
#include "DDDemo.h"
#include "ColorDepthDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CColorDepthDlg dialog


CColorDepthDlg::CColorDepthDlg(CWnd* pParent /*=NULL*/) 
	: CDialog(CColorDepthDlg::IDD, pParent), m_nDepth(0),
	m_bCompress(FALSE), m_bOptimize(TRUE)
{
	//{{AFX_DATA_INIT(CColorDepthDlg)
	//}}AFX_DATA_INIT
}


void CColorDepthDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CColorDepthDlg)
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CColorDepthDlg, CDialog)
	//{{AFX_MSG_MAP(CColorDepthDlg)
	ON_BN_CLICKED(IDC_RADIO_16BIT, OnRadio16bit)
	ON_BN_CLICKED(IDC_RADIO_16COLOR, OnRadio16color)
	ON_BN_CLICKED(IDC_RADIO_24BIT, OnRadio24bit)
	ON_BN_CLICKED(IDC_RADIO_256COLOR, OnRadio256color)
	ON_BN_CLICKED(IDC_RADIO_32BIT, OnRadio32bit)
	ON_BN_CLICKED(IDC_RADIO_4SHADES, OnRadio4shades)
	ON_BN_CLICKED(IDC_RADIO_MONO, OnRadioMono)
	ON_BN_CLICKED(IDC_CHECK_COMPRESS, OnCheckCompress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CColorDepthDlg message handlers

void CColorDepthDlg::EnableCheckBoxes()
{
	CWnd* pwCtrl = GetDlgItem(IDC_CHECK_COMPRESS);
	if( pwCtrl )
	{
		if( m_nDepth == 4 || m_nDepth == 8 )
			pwCtrl->EnableWindow();
		else
			pwCtrl->EnableWindow(FALSE);
	}

	pwCtrl = GetDlgItem(IDC_CHECK_OPTIMIZE);
	if( pwCtrl )
	{
		if( m_nDepth == 4 )
			pwCtrl->EnableWindow();
		else
			pwCtrl->EnableWindow(FALSE);
	}
}

void CColorDepthDlg::OnRadioMono() 
{
	m_nDepth = 1;
	EnableCheckBoxes();
}

void CColorDepthDlg::OnRadio4shades() 
{
	m_nDepth = 2;
	EnableCheckBoxes();
}

void CColorDepthDlg::OnRadio16color() 
{
	m_nDepth = 4;
	EnableCheckBoxes();
}

void CColorDepthDlg::OnRadio256color() 
{
	m_nDepth = 8;
	EnableCheckBoxes();
}

void CColorDepthDlg::OnRadio16bit() 
{
	m_nDepth = 16;
	EnableCheckBoxes();
}

void CColorDepthDlg::OnRadio24bit() 
{
	m_nDepth = 24;
	EnableCheckBoxes();
}

void CColorDepthDlg::OnRadio32bit() 
{
	m_nDepth = 32;
	EnableCheckBoxes();
}

void CColorDepthDlg::OnCheckCompress() 
{
	m_bCompress = !m_bCompress;
}

BOOL CColorDepthDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	switch( m_nDepth )
	{
	case  1:
		CheckRadioButton(IDC_RADIO_MONO, IDC_RADIO_32BIT, IDC_RADIO_MONO);
		break;
	case  2:
		CheckRadioButton(IDC_RADIO_MONO, IDC_RADIO_32BIT, IDC_RADIO_4SHADES);
		break;
	case  4:
		CheckRadioButton(IDC_RADIO_MONO, IDC_RADIO_32BIT, IDC_RADIO_16COLOR);
		break;
	case  8:
		CheckRadioButton(IDC_RADIO_MONO, IDC_RADIO_32BIT, IDC_RADIO_256COLOR);
		break;
	case 16:
		CheckRadioButton(IDC_RADIO_MONO, IDC_RADIO_32BIT, IDC_RADIO_16BIT);
		break;
	case 24:
		CheckRadioButton(IDC_RADIO_MONO, IDC_RADIO_32BIT, IDC_RADIO_24BIT);
		break;
	case 32:
		CheckRadioButton(IDC_RADIO_MONO, IDC_RADIO_32BIT, IDC_RADIO_32BIT);
		break;
	}

	CheckDlgButton(IDC_CHECK_COMPRESS, m_bCompress);
	CheckDlgButton(IDC_CHECK_OPTIMIZE, m_bOptimize);

	EnableCheckBoxes();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
